package com.hfkj.dao;

import com.hfkj.entity.BsUserAccountRecord;
import com.hfkj.entity.BsUserAccountRecordExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsUserAccountRecordMapper extends BsUserAccountRecordMapperExt {
    @SelectProvider(type=BsUserAccountRecordSqlProvider.class, method="countByExample")
    long countByExample(BsUserAccountRecordExample example);

    @DeleteProvider(type=BsUserAccountRecordSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsUserAccountRecordExample example);

    @Delete({
        "delete from bs_user_account_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_user_account_record (user_id, user_account_id, ",
        "`type`, transaction_amount, ",
        "before_amount, after_amount, ",
        "source_type, source_id, ",
        "source_order_no, source_content, ",
        "`status`, create_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{userId,jdbcType=BIGINT}, #{userAccountId,jdbcType=BIGINT}, ",
        "#{type,jdbcType=INTEGER}, #{transactionAmount,jdbcType=DECIMAL}, ",
        "#{beforeAmount,jdbcType=DECIMAL}, #{afterAmount,jdbcType=DECIMAL}, ",
        "#{sourceType,jdbcType=INTEGER}, #{sourceId,jdbcType=BIGINT}, ",
        "#{sourceOrderNo,jdbcType=VARCHAR}, #{sourceContent,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsUserAccountRecord record);

    @InsertProvider(type=BsUserAccountRecordSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsUserAccountRecord record);

    @SelectProvider(type=BsUserAccountRecordSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_account_id", property="userAccountId", jdbcType=JdbcType.BIGINT),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="transaction_amount", property="transactionAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="before_amount", property="beforeAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="after_amount", property="afterAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="source_type", property="sourceType", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="source_order_no", property="sourceOrderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="source_content", property="sourceContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsUserAccountRecord> selectByExample(BsUserAccountRecordExample example);

    @Select({
        "select",
        "id, user_id, user_account_id, `type`, transaction_amount, before_amount, after_amount, ",
        "source_type, source_id, source_order_no, source_content, `status`, create_time, ",
        "ext_1, ext_2, ext_3",
        "from bs_user_account_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_account_id", property="userAccountId", jdbcType=JdbcType.BIGINT),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="transaction_amount", property="transactionAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="before_amount", property="beforeAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="after_amount", property="afterAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="source_type", property="sourceType", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="source_order_no", property="sourceOrderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="source_content", property="sourceContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsUserAccountRecord selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsUserAccountRecordSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsUserAccountRecord record, @Param("example") BsUserAccountRecordExample example);

    @UpdateProvider(type=BsUserAccountRecordSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsUserAccountRecord record, @Param("example") BsUserAccountRecordExample example);

    @UpdateProvider(type=BsUserAccountRecordSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsUserAccountRecord record);

    @Update({
        "update bs_user_account_record",
        "set user_id = #{userId,jdbcType=BIGINT},",
          "user_account_id = #{userAccountId,jdbcType=BIGINT},",
          "`type` = #{type,jdbcType=INTEGER},",
          "transaction_amount = #{transactionAmount,jdbcType=DECIMAL},",
          "before_amount = #{beforeAmount,jdbcType=DECIMAL},",
          "after_amount = #{afterAmount,jdbcType=DECIMAL},",
          "source_type = #{sourceType,jdbcType=INTEGER},",
          "source_id = #{sourceId,jdbcType=BIGINT},",
          "source_order_no = #{sourceOrderNo,jdbcType=VARCHAR},",
          "source_content = #{sourceContent,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsUserAccountRecord record);
}