package com.hfkj.dao;

import com.hfkj.entity.BsUserInviteCode;
import com.hfkj.entity.BsUserInviteCodeExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsUserInviteCodeMapper extends BsUserInviteCodeMapperExt {
    @SelectProvider(type=BsUserInviteCodeSqlProvider.class, method="countByExample")
    long countByExample(BsUserInviteCodeExample example);

    @DeleteProvider(type=BsUserInviteCodeSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsUserInviteCodeExample example);

    @Delete({
        "delete from bs_user_invite_code",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_user_invite_code (user_id, invite_code, ",
        "qr_code_img, `status`, ",
        "create_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{userId,jdbcType=BIGINT}, #{inviteCode,jdbcType=VARCHAR}, ",
        "#{qrCodeImg,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsUserInviteCode record);

    @InsertProvider(type=BsUserInviteCodeSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsUserInviteCode record);

    @SelectProvider(type=BsUserInviteCodeSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="invite_code", property="inviteCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="qr_code_img", property="qrCodeImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsUserInviteCode> selectByExample(BsUserInviteCodeExample example);

    @Select({
        "select",
        "id, user_id, invite_code, qr_code_img, `status`, create_time, ext_1, ext_2, ",
        "ext_3",
        "from bs_user_invite_code",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="invite_code", property="inviteCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="qr_code_img", property="qrCodeImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsUserInviteCode selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsUserInviteCodeSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsUserInviteCode record, @Param("example") BsUserInviteCodeExample example);

    @UpdateProvider(type=BsUserInviteCodeSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsUserInviteCode record, @Param("example") BsUserInviteCodeExample example);

    @UpdateProvider(type=BsUserInviteCodeSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsUserInviteCode record);

    @Update({
        "update bs_user_invite_code",
        "set user_id = #{userId,jdbcType=BIGINT},",
          "invite_code = #{inviteCode,jdbcType=VARCHAR},",
          "qr_code_img = #{qrCodeImg,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsUserInviteCode record);
}