package com.hfkj.service.user;

import com.hfkj.entity.BsUserAccount;
import com.hfkj.sysenum.user.UserAccountRecordSourceTypeEnum;

import java.math.BigDecimal;
import java.util.Map;

/**
 * @className: BsUserAccountService
 * @author: HuRui
 * @date: 2024/9/8
 **/
public interface BsUserAccountService {

    /**
     * 创建账户
     * @param userId
     */
    void create(Long userId);

    /**
     * 查询账户
     * @param userId 用户id
     */
    BsUserAccount getAccount(Long userId);

    /**
     * 充值
     * @param userId         用户id
     * @param amount         金额
     * @param otherParam     其他参数
     */
    void recharge(Long userId, BigDecimal amount, UserAccountRecordSourceTypeEnum sourceType, Map<String, Object> otherParam) throws Exception;

    /**
     * 扣除
     * @param userId         用户id
     * @param amount         金额
     * @param otherParam     其他参数
     */
    void consume(Long userId, BigDecimal amount, UserAccountRecordSourceTypeEnum sourceType,Map<String, Object> otherParam) throws Exception;

}
