package com.hfkj.service.user;

import com.hfkj.common.security.SessionObject;
import com.hfkj.entity.BsUser;
import com.hfkj.sysenum.user.UserLoginType;

import java.util.Map;

/**
 * @className: BsUserService
 * @author: HuRui
 * @date: 2024/9/6
 **/
public interface BsUserService {

    /**
     * 编辑数据
     * @param data
     */
    void editData(BsUser data);

    /**
     * 更新手机号
     * @param userId
     * @param newPhone
     */
    void updatePhone(Long userId, String newPhone) throws Exception;

    /**
     * 修改微信号
     * @param userId
     * @param wechatNum
     */
    void updateWechatNum(Long userId, String wechatNum) throws Exception;

    /**
     * 查询详情
     * @param userId
     * @return
     */
    BsUser getUser(Long userId);

    /**
     * 查询详情SmsController
     * @param userPhone
     * @return
     */
    BsUser getUser(String userPhone);

     /**
     * 用户注册
     * @param phone    手机号
     * @param other    其他参数
     * @return
     * @throws Exception
     */
    BsUser register(String phone, Map<String, Object> other, String inviteCode);

    /**
     * 用户登录
     * @param phone    用户手机号
     * @param other    其他参数
     * @return
     * @throws Exception
     */
    SessionObject login(String phone, UserLoginType loginType, Map<String, Object> other,String inviteCode) throws Exception;

}
