package com.hfkj.service.user.impl;

import com.hfkj.dao.BsUserAccountRecordMapper;
import com.hfkj.entity.BsUserAccountRecord;
import com.hfkj.entity.BsUserAccountRecordExample;
import com.hfkj.service.user.BsUserAccountRecordService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @className: BsUserAccountRecordServiceImpl
 * @author: HuRui
 * @date: 2024/9/8
 **/
@Service("userAccountRecordService")
public class BsUserAccountRecordServiceImpl implements BsUserAccountRecordService {
    @Resource
    private BsUserAccountRecordMapper userAccountRecordMapper;
    @Override
    public void create(BsUserAccountRecord data) {
        data.setStatus(1);
        data.setCreateTime(new Date());
        userAccountRecordMapper.insert(data);
    }

    @Override
    public BsUserAccountRecord getDetail(Long id) {
        return userAccountRecordMapper.selectByPrimaryKey(id);
    }

    @Override
    public List<BsUserAccountRecord> getList(Map<String, Object> param) {
        BsUserAccountRecordExample example = new BsUserAccountRecordExample();
        BsUserAccountRecordExample.Criteria criteria = example.createCriteria().andStatusNotEqualTo(0);

        if (MapUtils.getLong(param, "userId") != null) {
            criteria.andUserIdEqualTo(MapUtils.getLong(param, "userId"));
        }

        if (MapUtils.getInteger(param, "type") != null) {
            criteria.andTypeEqualTo(MapUtils.getInteger(param, "type"));
        }

        if (MapUtils.getInteger(param, "sourceType") != null) {
            criteria.andSourceTypeEqualTo(MapUtils.getInteger(param, "sourceType"));
        }

        example.setOrderByClause("create_time desc");
        return userAccountRecordMapper.selectByExample(example);
    }
}
