package com.hfkj.sysenum.user;

import lombok.Getter;

import java.util.Objects;

/**
 * 登录方式
 * @className: LoginType
 * @author: HuRui
 * @date: 2022/10/20
 **/
@Getter
public enum UserLoginType {
    /**
     * 短信登录
     */
    SMS("SMS", "短信登录"),
    /**
     * 微信授权
     */
    WECHAT_EMPOWER("WECHAT_EMPOWER", "微信授权"),
            ;

    private String code;

    private String name;

    UserLoginType(String code, String name) {
        this.code = code;
        this.name = name;
    }

    /**
     * 根据类型查询数据
     * @param code
     * @return
     */
    public static UserLoginType getDataByType(String code) {
        for (UserLoginType ele : values()) {
            if (Objects.equals(code,ele.getCode())) return ele;
        }
        return null;
    }

}
